%PAKCS1.6V8 SEPARATE VARIABLESHARING

:-prolog_flag(single_var_warnings,A,off).
:-prolog_flag(redefine_warnings,A,off).

:-importModule(prelude).


:-curryModule('Char').

%%%%%%%%%%%% function types %%%%%%%%%%%%%%%%%%%
:-multifile functiontype/6.
:-dynamic functiontype/6.
functiontype('Char.isUpper',isUpper,1,'Char.isUpper',nofix,'FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isLower',isLower,1,'Char.isLower',nofix,'FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isAlpha',isAlpha,1,'Char.isAlpha',nofix,'FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isDigit',isDigit,1,'Char.isDigit',nofix,'FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isAlphaNum',isAlphaNum,1,'Char.isAlphaNum',nofix,'FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isOctDigit',isOctDigit,1,'Char.isOctDigit',nofix,'FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isHexDigit',isHexDigit,1,'Char.isHexDigit',nofix,'FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.isSpace',isSpace,1,'Char.isSpace',nofix,'FuncType'('TCons'('Char',[]),'TCons'('Bool',[]))).
functiontype('Char.toUpper',toUpper,1,'Char.toUpper',nofix,'FuncType'('TCons'('Char',[]),'TCons'('Char',[]))).
functiontype('Char.toLower',toLower,1,'Char.toLower',nofix,'FuncType'('TCons'('Char',[]),'TCons'('Char',[]))).
functiontype('Char.digitToInt',digitToInt,1,'Char.digitToInt',nofix,'FuncType'('TCons'('Char',[]),'TCons'('Int',[]))).
functiontype('Char.intToDigit',intToDigit,1,'Char.intToDigit',nofix,'FuncType'('TCons'('Int',[]),'TCons'('Char',[]))).

%%%%%%%%%%%% constructor types %%%%%%%%%%%%%%%%%%%
:-multifile constructortype/4.
:-dynamic constructortype/4.

%%%%%%%%%%%% function definitions %%%%%%%%%%%%%%%%%%%
:- block 'Char.isUpper'(?,?,-,?).
'Char.isUpper'(A,B,C,D):-makeShare(A,E),hnf(&&(ord(E)>=ord('\'A'),<=(ord(E),ord('\'Z'))),B,C,D).

:- block 'Char.isLower'(?,?,-,?).
'Char.isLower'(A,B,C,D):-makeShare(A,E),hnf(&&(ord(E)>=ord('\'a'),<=(ord(E),ord('\'z'))),B,C,D).

:- block 'Char.isAlpha'(?,?,-,?).
'Char.isAlpha'(A,B,C,D):-makeShare(A,E),hnf('||'('Char.isUpper'(E),'Char.isLower'(E)),B,C,D).

:- block 'Char.isDigit'(?,?,-,?).
'Char.isDigit'(A,B,C,D):-makeShare(A,E),hnf(&&(<=(ord('\'0'),ord(E)),<=(ord(E),ord('\'9'))),B,C,D).

:- block 'Char.isAlphaNum'(?,?,-,?).
'Char.isAlphaNum'(A,B,C,D):-makeShare(A,E),hnf('||'('Char.isAlpha'(E),'Char.isDigit'(E)),B,C,D).

:- block 'Char.isOctDigit'(?,?,-,?).
'Char.isOctDigit'(A,B,C,D):-makeShare(A,E),hnf(&&(ord(E)>=ord('\'0'),<=(ord(E),ord('\'7'))),B,C,D).

:- block 'Char.isHexDigit'(?,?,-,?).
'Char.isHexDigit'(A,B,C,D):-makeShare(A,E),hnf('||'('Char.isDigit'(E),'||'(&&(ord(E)>=ord('\'A'),<=(ord(E),ord('\'F'))),&&(ord(E)>=ord('\'a'),<=(ord(E),ord('\'f'))))),B,C,D).

:- block 'Char.isSpace'(?,?,-,?).
'Char.isSpace'(A,B,C,D):-makeShare(A,E),hnf('||'(E=='\' ','||'(E=='\'\t','||'(E=='\'\n','||'(E=='\'\r',ord(E)==12)))),B,C,D).

:- block 'Char.toUpper'(?,?,-,?).
'Char.toUpper'(A,B,C,D):-makeShare(A,E),hnf(if_then_else('Char.isLower'(E),chr(ord(E)-ord('\'a')+ord('\'A')),E),B,C,D).

:- block 'Char.toLower'(?,?,-,?).
'Char.toLower'(A,B,C,D):-makeShare(A,E),hnf(if_then_else('Char.isUpper'(E),chr(ord(E)-ord('\'A')+ord('\'a')),E),B,C,D).

:- block 'Char.digitToInt'(?,?,-,?).
'Char.digitToInt'(A,B,C,D):-makeShare(A,E),hnf(if_then_else('Char.isDigit'(E),ord(E)-ord('\'0'),if_then_else(&&(ord(E)>=ord('\'A'),<=(ord(E),ord('\'F'))),ord(E)-ord('\'A')+10,if_then_else(&&(ord(E)>=ord('\'a'),<=(ord(E),ord('\'f'))),ord(E)-ord('\'a')+10,error(['\'C','\'h','\'a','\'r','\'.','\'d','\'i','\'g','\'i','\'t','\'T','\'o','\'I','\'n','\'t','\':','\' ','\'a','\'r','\'g','\'u','\'m','\'e','\'n','\'t','\' ','\'i','\'s','\' ','\'n','\'o','\'t','\' ','\'a','\' ','\'d','\'i','\'g','\'i','\'t'])))),B,C,D).

:- block 'Char.intToDigit'(?,?,-,?).
'Char.intToDigit'(A,B,C,D):-makeShare(A,E),hnf(if_then_else(&&(E>=0,<=(E,9)),chr(ord('\'0')+E),if_then_else(&&(E>=10,<=(E,15)),chr(ord('\'A')+E-10),error(['\'C','\'h','\'a','\'r','\'.','\'i','\'n','\'t','\'T','\'o','\'D','\'i','\'g','\'i','\'t','\':','\' ','\'a','\'r','\'g','\'u','\'m','\'e','\'n','\'t','\' ','\'n','\'o','\'t','\' ','\'a','\' ','\'d','\'i','\'g','\'i','\'t','\' ','\'v','\'a','\'l','\'u','\'e']))),B,C,D).

:-costCenters(['']).




%%%%% Number of shared variables: 12
