%PAKCS1.6V8 SEPARATE VARIABLESHARING

:-prolog_flag(single_var_warnings,A,off).
:-prolog_flag(redefine_warnings,A,off).

:-importModule(prelude).


:-curryModule('Combinatorial').

%%%%%%%%%%%% function types %%%%%%%%%%%%%%%%%%%
:-multifile functiontype/6.
:-dynamic functiontype/6.
functiontype('Combinatorial.permute',permute,1,'Combinatorial.permute',nofix,'FuncType'('TCons'([],[A]),'TCons'([],[A]))).
functiontype('Combinatorial.subset',subset,1,'Combinatorial.subset',nofix,'FuncType'('TCons'([],[A]),'TCons'([],[A]))).
functiontype('Combinatorial.allSubsets','Combinatorial.allSubsets',1,'Combinatorial.allSubsets',nofix,'FuncType'('TCons'([],[A]),'TCons'([],['TCons'([],[A])]))).
functiontype('Combinatorial.splitSet',splitSet,1,'Combinatorial.splitSet',nofix,'FuncType'('TCons'([],[A]),'TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])]))).
functiontype('Combinatorial.sizedSubset',sizedSubset,2,'Combinatorial.sizedSubset',nofix,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype('Combinatorial.partition',partition,1,'Combinatorial.partition',nofix,'FuncType'('TCons'([],[A]),'TCons'([],['TCons'([],[A])]))).
functiontype('Combinatorial.ndinsert_0','Combinatorial.ndinsert_0',2,'Combinatorial.ndinsert_0',nofix,'FuncType'(A,'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype('Combinatorial.combinatorial_lambda0_0','Combinatorial.combinatorial_lambda0_0',2,'Combinatorial.combinatorial_lambda0_0',nofix,'FuncType'('TCons'([],[A]),'FuncType'('TCons'([],[A]),'TCons'('Success',[])))).
functiontype('Combinatorial.combinatorial_lambda1_0','Combinatorial.combinatorial_lambda1_0',2,'Combinatorial.combinatorial_lambda1_0',nofix,'FuncType'(A,'FuncType'('TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])]),'TCons'('(,)',['TCons'([],[A]),'TCons'([],[A])])))).
functiontype('Combinatorial.aux_0','Combinatorial.aux_0',2,'Combinatorial.aux_0',nofix,'FuncType'('TCons'('Int',[]),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype('Combinatorial.insert_0','Combinatorial.insert_0',2,'Combinatorial.insert_0',nofix,'FuncType'(A,'FuncType'('TCons'([],['TCons'([],[A])]),'TCons'([],['TCons'([],[A])])))).

%%%%%%%%%%%% constructor types %%%%%%%%%%%%%%%%%%%
:-multifile constructortype/4.
:-dynamic constructortype/4.

%%%%%%%%%%%% function definitions %%%%%%%%%%%%%%%%%%%
:- block 'Combinatorial.permute'(?,?,-,?).
'Combinatorial.permute'(A,B,C,D):-hnf(A,E,C,F),'Combinatorial.permute_1'(E,B,F,D).

:- block 'Combinatorial.permute_1'(?,?,-,?).
'Combinatorial.permute_1'([],[],A,A).
'Combinatorial.permute_1'([A|B],C,D,E):-'Combinatorial.ndinsert_0'(A,'Combinatorial.permute'(B),C,D,E).

:- block 'Combinatorial.subset'(?,?,-,?).
'Combinatorial.subset'(A,B,C,D):-hnf(A,E,C,F),'Combinatorial.subset_1'(E,B,F,D).

:- block 'Combinatorial.subset_1'(?,?,-,?).
'Combinatorial.subset_1'([],[],A,A).
'Combinatorial.subset_1'([A|B],[A|'Combinatorial.subset'(B)],C,C).
'Combinatorial.subset_1'([A|B],C,D,E):-'Combinatorial.subset'(B,C,D,E).

:- block 'Combinatorial.allSubsets'(?,?,-,?).
'Combinatorial.allSubsets'(A,B,C,D):-hnf(findall(partcall(1,'Combinatorial.combinatorial_lambda0_0',[A])),B,C,D).

:- block 'Combinatorial.splitSet'(?,?,-,?).
'Combinatorial.splitSet'(A,B,C,D):-hnf(A,E,C,F),'Combinatorial.splitSet_1'(E,B,F,D).

:- block 'Combinatorial.splitSet_1'(?,?,-,?).
'Combinatorial.splitSet_1'([],'(,)'([],[]),A,A).
'Combinatorial.splitSet_1'([A|B],C,D,E):-'Combinatorial.combinatorial_lambda1_0'(A,'Combinatorial.splitSet'(B),C,D,E).

:- block 'Combinatorial.sizedSubset'(?,?,?,-,?).
'Combinatorial.sizedSubset'(A,B,C,D,E):-makeShare(A,F),hnf(if_then_else(F==0,[],'Combinatorial.aux_0'(F,B)),C,D,E).

:- block 'Combinatorial.partition'(?,?,-,?).
'Combinatorial.partition'(A,B,C,D):-hnf(A,E,C,F),'Combinatorial.partition_1'(E,B,F,D).

:- block 'Combinatorial.partition_1'(?,?,-,?).
'Combinatorial.partition_1'([],[],A,A).
'Combinatorial.partition_1'([A|B],C,D,E):-'Combinatorial.insert_0'(A,'Combinatorial.partition'(B),C,D,E).

:- block 'Combinatorial.ndinsert_0'(?,?,?,-,?).
'Combinatorial.ndinsert_0'(A,B,C,D,E):-hnf(B,F,D,G),'Combinatorial.ndinsert_0_2'(F,A,C,G,E).

:- block 'Combinatorial.ndinsert_0_2'(?,?,?,-,?).
'Combinatorial.ndinsert_0_2'([],A,[A],B,B).
'Combinatorial.ndinsert_0_2'([A|B],C,D,E,F):-makeShare(C,G),makeShare(A,H),makeShare(B,I),hnf(?([G,H|I],[H|'Combinatorial.ndinsert_0'(G,I)]),D,E,F).

:- block 'Combinatorial.combinatorial_lambda0_0'(?,?,?,-,?).
'Combinatorial.combinatorial_lambda0_0'(A,B,C,D,E):-hnf('Combinatorial.subset'(A)=:=B,C,D,E).

:- block 'Combinatorial.combinatorial_lambda1_0'(?,?,?,-,?).
'Combinatorial.combinatorial_lambda1_0'(A,B,C,D,E):-hnf(B,F,D,G),'Combinatorial.combinatorial_lambda1_0_2'(F,A,C,G,E).

:- block 'Combinatorial.combinatorial_lambda1_0_2'(?,?,?,-,?).
'Combinatorial.combinatorial_lambda1_0_2'('(,)'(A,B),C,D,E,F):-makeShare(C,G),makeShare(A,H),makeShare(B,I),hnf(?('(,)'([G|H],I),'(,)'(H,[G|I])),D,E,F).

:- block 'Combinatorial.aux_0'(?,?,?,-,?).
'Combinatorial.aux_0'(A,B,C,D,E):-hnf(B,F,D,G),'Combinatorial.aux_0_2'(F,A,C,G,E).

:- block 'Combinatorial.aux_0_2'(?,?,?,-,?).
'Combinatorial.aux_0_2'([A|B],C,D,E,F):-makeShare(C,G),makeShare(B,H),hnf(?([A|'Combinatorial.sizedSubset'(G-1,H)],'Combinatorial.sizedSubset'(G,H)),D,E,F).

:- block 'Combinatorial.insert_0'(?,?,?,-,?).
'Combinatorial.insert_0'(A,B,C,D,E):-hnf(B,F,D,G),'Combinatorial.insert_0_2'(F,A,C,G,E).

:- block 'Combinatorial.insert_0_2'(?,?,?,-,?).
'Combinatorial.insert_0_2'([],A,[[A]],B,B).
'Combinatorial.insert_0_2'([A|B],C,D,E,F):-makeShare(C,G),makeShare(A,H),makeShare(B,I),hnf(?([[G|H]|I],[H|'Combinatorial.insert_0'(G,I)]),D,E,F).

:-costCenters(['']).




%%%%% Number of shared variables: 12
