%PAKCS1.6V8 SEPARATE VARIABLESHARING

:-prolog_flag(single_var_warnings,A,off).
:-prolog_flag(redefine_warnings,A,off).

:-importModule(prelude).
:-importModule('RedBlackTree').
:-importModule('RedBlackTree').
:-importModule('Maybe').


:-curryModule('SetRBT').

%%%%%%%%%%%% function types %%%%%%%%%%%%%%%%%%%
:-multifile functiontype/6.
:-dynamic functiontype/6.
functiontype('SetRBT.emptySetRBT',emptySetRBT,1,'SetRBT.emptySetRBT',nofix,'FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'TCons'('RedBlackTree.RedBlackTree',[A]))).
functiontype('SetRBT.elemRBT',elemRBT,2,'SetRBT.elemRBT',nofix,'FuncType'(A,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[A]),'TCons'('Bool',[])))).
functiontype('SetRBT.insertRBT',insertRBT,2,'SetRBT.insertRBT',nofix,'FuncType'(A,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[A]),'TCons'('RedBlackTree.RedBlackTree',[A])))).
functiontype('SetRBT.insertMultiRBT',insertMultiRBT,2,'SetRBT.insertMultiRBT',nofix,'FuncType'(A,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[A]),'TCons'('RedBlackTree.RedBlackTree',[A])))).
functiontype('SetRBT.deleteRBT',deleteRBT,2,'SetRBT.deleteRBT',nofix,'FuncType'(A,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[A]),'TCons'('RedBlackTree.RedBlackTree',[A])))).
functiontype('SetRBT.setRBT2list',setRBT2list,1,'SetRBT.setRBT2list',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[A]),'TCons'([],[A]))).
functiontype('SetRBT.unionRBT',unionRBT,2,'SetRBT.unionRBT',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[A]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[A]),'TCons'('RedBlackTree.RedBlackTree',[A])))).
functiontype('SetRBT.intersectRBT',intersectRBT,2,'SetRBT.intersectRBT',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[A]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[A]),'TCons'('RedBlackTree.RedBlackTree',[A])))).
functiontype('SetRBT.sortRBT',sortRBT,2,'SetRBT.sortRBT',nofix,'FuncType'('FuncType'(A,'FuncType'(A,'TCons'('Bool',[]))),'FuncType'('TCons'([],[A]),'TCons'([],[A])))).
functiontype('SetRBT.setRBT_lambda0_0','SetRBT.setRBT_lambda0_0',2,'SetRBT.setRBT_lambda0_0',nofix,'FuncType'(A,'FuncType'(A,'TCons'('Bool',[])))).
functiontype('SetRBT.setRBT_lambda1_0','SetRBT.setRBT_lambda1_0',2,'SetRBT.setRBT_lambda1_0',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[A]),'FuncType'(A,'TCons'('Bool',[])))).

%%%%%%%%%%%% constructor types %%%%%%%%%%%%%%%%%%%
:-multifile constructortype/4.
:-dynamic constructortype/4.

%%%%%%%%%%%% function definitions %%%%%%%%%%%%%%%%%%%
:- block 'SetRBT.emptySetRBT'(?,?,-,?).
'SetRBT.emptySetRBT'(A,B,C,D):-hnf(apply(partcall(1,'RedBlackTree.empty',[partcall(2,==,[]),partcall(2,==,[])]),A),B,C,D).

:- block 'SetRBT.elemRBT'(?,?,?,-,?).
'SetRBT.elemRBT'(A,B,C,D,E):-hnf(apply(partcall(1,'prelude..',[partcall(1,'RedBlackTree.lookup',[A]),partcall(1,'Maybe.isJust',[])]),B),C,D,E).

:- block 'SetRBT.insertRBT'(?,?,?,-,?).
'SetRBT.insertRBT'(A,B,C,D,E):-hnf(apply(apply(partcall(2,'RedBlackTree.update',[]),A),B),C,D,E).

:- block 'SetRBT.insertMultiRBT'(?,?,?,-,?).
'SetRBT.insertMultiRBT'(A,B,C,D,E):-hnf(apply(partcall(1,'prelude..',[partcall(1,'prelude..',[partcall(1,'RedBlackTree.setInsertEquivalence',[partcall(2,'SetRBT.setRBT_lambda0_0',[])]),partcall(1,'RedBlackTree.update',[A])]),partcall(1,'RedBlackTree.setInsertEquivalence',[partcall(2,==,[])])]),B),C,D,E).

:- block 'SetRBT.deleteRBT'(?,?,?,-,?).
'SetRBT.deleteRBT'(A,B,C,D,E):-hnf(apply(apply(partcall(2,'RedBlackTree.delete',[]),A),B),C,D,E).

:- block 'SetRBT.setRBT2list'(?,?,-,?).
'SetRBT.setRBT2list'(A,B,C,D):-hnf(apply(partcall(1,'RedBlackTree.tree2list',[]),A),B,C,D).

:- block 'SetRBT.unionRBT'(?,?,?,-,?).
'SetRBT.unionRBT'(A,B,C,D,E):-hnf(foldr(partcall(2,'SetRBT.insertRBT',[]),B,apply(partcall(1,'SetRBT.setRBT2list',[]),A)),C,D,E).

:- block 'SetRBT.intersectRBT'(?,?,?,-,?).
'SetRBT.intersectRBT'(A,B,C,D,E):-makeShare(A,F),hnf(foldr(partcall(2,'SetRBT.insertRBT',[]),'RedBlackTree.newTreeLike'(F),filter(partcall(1,'SetRBT.setRBT_lambda1_0',[B]),apply(partcall(1,'SetRBT.setRBT2list',[]),F))),C,D,E).

:- block 'SetRBT.sortRBT'(?,?,?,-,?).
'SetRBT.sortRBT'(A,B,C,D,E):-hnf(apply(apply(partcall(2,'RedBlackTree.sort',[]),A),B),C,D,E).

:- block 'SetRBT.setRBT_lambda0_0'(?,?,?,-,?).
'SetRBT.setRBT_lambda0_0'(A,B,'False',C,C).

:- block 'SetRBT.setRBT_lambda1_0'(?,?,?,-,?).
'SetRBT.setRBT_lambda1_0'(A,B,C,D,E):-hnf(apply(partcall(1,'SetRBT.elemRBT',[B]),A),C,D,E).

:-costCenters(['']).




%%%%% Number of shared variables: 1
