%PAKCS1.6V8 SEPARATE VARIABLESHARING

:-prolog_flag(single_var_warnings,A,off).
:-prolog_flag(redefine_warnings,A,off).

:-importModule(prelude).
:-importModule('Char').

:-ensure_lib_loaded(prim_unsafe).

:-curryModule('Unsafe').

%%%%%%%%%%%% function types %%%%%%%%%%%%%%%%%%%
:-multifile functiontype/6.
:-dynamic functiontype/6.
functiontype('Unsafe.unsafePerformIO',unsafePerformIO,1,prim_unsafePerformIO,nofix,'FuncType'('TCons'('IO',[A]),A)).
functiontype('Unsafe.spawnConstraint',spawnConstraint,2,prim_spawnConstraint,nofix,'FuncType'('TCons'('Success',[]),'FuncType'(A,A))).
functiontype('Unsafe.prim_isVar','Unsafe.prim_isVar',1,prim_isVar,nofix,'FuncType'(A,'TCons'('Bool',[]))).
functiontype('Unsafe.prim_identicalVar','Unsafe.prim_identicalVar',2,prim_identicalVar,nofix,'FuncType'(A,'FuncType'(A,'TCons'('Bool',[])))).
functiontype('Unsafe.prim_showAnyTerm','Unsafe.prim_showAnyTerm',1,prim_showAnyTerm,nofix,'FuncType'(A,'TCons'([],['TCons'('Char',[])]))).
functiontype('Unsafe.prim_showAnyQTerm','Unsafe.prim_showAnyQTerm',1,prim_showAnyQTerm,nofix,'FuncType'(A,'TCons'([],['TCons'('Char',[])]))).
functiontype('Unsafe.prim_readsAnyUnqualifiedTerm','Unsafe.prim_readsAnyUnqualifiedTerm',2,prim_readsAnyUnqualifiedTerm,nofix,'FuncType'('TCons'([],['TCons'([],['TCons'('Char',[])])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('(,)',[A,'TCons'([],['TCons'('Char',[])])])])))).
functiontype('Unsafe.prim_readsAnyQTerm','Unsafe.prim_readsAnyQTerm',1,prim_readsAnyQTerm,nofix,'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('(,)',[A,'TCons'([],['TCons'('Char',[])])])]))).
functiontype('Unsafe.showAnyExpression',showAnyExpression,1,prim_showAnyExpression,nofix,'FuncType'(A,'TCons'([],['TCons'('Char',[])]))).
functiontype('Unsafe.showAnyQExpression',showAnyQExpression,1,prim_showAnyQExpression,nofix,'FuncType'(A,'TCons'([],['TCons'('Char',[])]))).
functiontype('Unsafe.trace',trace,2,'Unsafe.trace',nofix,'FuncType'('TCons'([],['TCons'('Char',[])]),'FuncType'(A,A))).
functiontype('Unsafe.isVar',isVar,1,'Unsafe.isVar',nofix,'FuncType'(A,'TCons'('Bool',[]))).
functiontype('Unsafe.identicalVar',identicalVar,2,'Unsafe.identicalVar',nofix,'FuncType'(A,'FuncType'(A,'TCons'('Bool',[])))).
functiontype('Unsafe.showAnyTerm',showAnyTerm,1,prim_showAnyTerm,nofix,'FuncType'(A,'TCons'([],['TCons'('Char',[])]))).
functiontype('Unsafe.showAnyQTerm',showAnyQTerm,1,prim_showAnyQTerm,nofix,'FuncType'(A,'TCons'([],['TCons'('Char',[])]))).
functiontype('Unsafe.readsAnyUnqualifiedTerm',readsAnyUnqualifiedTerm,2,'Unsafe.readsAnyUnqualifiedTerm',nofix,'FuncType'('TCons'([],['TCons'([],['TCons'('Char',[])])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('(,)',[A,'TCons'([],['TCons'('Char',[])])])])))).
functiontype('Unsafe.readsAnyUnqualifiedTermWithPrefixes','Unsafe.readsAnyUnqualifiedTermWithPrefixes',2,prim_readsAnyUnqualifiedTerm,nofix,'FuncType'('TCons'([],['TCons'([],['TCons'('Char',[])])]),'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('(,)',[A,'TCons'([],['TCons'('Char',[])])])])))).
functiontype('Unsafe.readAnyUnqualifiedTerm',readAnyUnqualifiedTerm,2,'Unsafe.readAnyUnqualifiedTerm',nofix,'FuncType'('TCons'([],['TCons'([],['TCons'('Char',[])])]),'FuncType'('TCons'([],['TCons'('Char',[])]),A))).
functiontype('Unsafe.readsAnyQTerm',readsAnyQTerm,1,prim_readsAnyQTerm,nofix,'FuncType'('TCons'([],['TCons'('Char',[])]),'TCons'([],['TCons'('(,)',[A,'TCons'([],['TCons'('Char',[])])])]))).
functiontype('Unsafe.readAnyQTerm',readAnyQTerm,1,'Unsafe.readAnyQTerm',nofix,'FuncType'('TCons'([],['TCons'('Char',[])]),A)).
functiontype('Unsafe.unsafe_lambda0_0','Unsafe.unsafe_lambda0_0',1,'Unsafe.unsafe_lambda0_0',nofix,'FuncType'('TCons'([],['TCons'('(,)',[A,'TCons'([],['TCons'('Char',[])])])]),A)).
functiontype('Unsafe.unsafe_lambda1_0','Unsafe.unsafe_lambda1_0',1,'Unsafe.unsafe_lambda1_0',nofix,'FuncType'('TCons'([],['TCons'('(,)',[A,'TCons'([],['TCons'('Char',[])])])]),A)).

%%%%%%%%%%%% constructor types %%%%%%%%%%%%%%%%%%%
:-multifile constructortype/4.
:-dynamic constructortype/4.

%%%%%%%%%%%% function definitions %%%%%%%%%%%%%%%%%%%
:- block 'Unsafe.trace'(?,?,?,-,?).
'Unsafe.trace'(A,B,C,D,E):-prim_unsafePerformIO(partcall(1,>>,[partcall(1,return,[B]),partcall(1,putStr,[A])]),C,D,E).

:- block 'Unsafe.isVar'(?,?,-,?).
'Unsafe.isVar'(A,B,C,D):-makeShare(A,E),hnf(seq(E,'Unsafe.prim_isVar'(E)),B,C,D).

:- block 'Unsafe.identicalVar'(?,?,?,-,?).
'Unsafe.identicalVar'(A,B,C,D,E):-makeShare(A,F),makeShare(B,G),hnf(seq(F,seq(G,'Unsafe.prim_identicalVar'(F,G))),C,D,E).

:- block 'Unsafe.readsAnyUnqualifiedTerm'(?,?,?,-,?).
'Unsafe.readsAnyUnqualifiedTerm'(A,B,C,D,E):-hnf(A,F,D,G),'Unsafe.readsAnyUnqualifiedTerm_1'(F,B,C,G,E).

:- block 'Unsafe.readsAnyUnqualifiedTerm_1'(?,?,?,-,?).
'Unsafe.readsAnyUnqualifiedTerm_1'([],A,B,C,D):-hnf(error(['\'R','\'e','\'a','\'d','\'S','\'h','\'o','\'w','\'T','\'e','\'r','\'m','\'.','\'r','\'e','\'a','\'d','\'s','\'A','\'n','\'y','\'U','\'n','\'q','\'u','\'a','\'l','\'i','\'f','\'i','\'e','\'d','\'T','\'e','\'r','\'m','\':','\' ','\'l','\'i','\'s','\'t','\' ','\'o','\'f','\' ','\'m','\'o','\'d','\'u','\'l','\'e','\' ','\'p','\'r','\'e','\'f','\'i','\'x','\'e','\'s','\' ','\'i','\'s','\' ','\'e','\'m','\'p','\'t','\'y']),B,C,D).
'Unsafe.readsAnyUnqualifiedTerm_1'([A|B],C,D,E,F):-prim_readsAnyUnqualifiedTerm([A|B],C,D,E,F).

:- block 'Unsafe.readAnyUnqualifiedTerm'(?,?,?,-,?).
'Unsafe.readAnyUnqualifiedTerm'(A,B,C,D,E):-'Unsafe.unsafe_lambda0_0'('Unsafe.readsAnyUnqualifiedTerm'(A,B),C,D,E).

:- block 'Unsafe.readAnyQTerm'(?,?,-,?).
'Unsafe.readAnyQTerm'(A,B,C,D):-'Unsafe.unsafe_lambda1_0'('Unsafe.readsAnyQTerm'(A),B,C,D).

:- block 'Unsafe.unsafe_lambda0_0'(?,?,-,?).
'Unsafe.unsafe_lambda0_0'(A,B,C,D):-hnf(A,E,C,F),'Unsafe.unsafe_lambda0_0_1'(E,B,F,D).

:- block 'Unsafe.unsafe_lambda0_0_1'(-,?,?,?),'Unsafe.unsafe_lambda0_0_1'(?,?,-,?).
'Unsafe.unsafe_lambda0_0_1'([A|B],C,D,E):-hnf(A,F,D,G),'Unsafe.unsafe_lambda0_0_1_._1'(F,B,C,G,E).

:- block 'Unsafe.unsafe_lambda0_0_1_._1'(-,?,?,?,?),'Unsafe.unsafe_lambda0_0_1_._1'(?,?,?,-,?).
'Unsafe.unsafe_lambda0_0_1_._1'('(,)'(A,B),C,D,E,F):-hnf(C,G,E,H),'Unsafe.unsafe_lambda0_0_1_._1_(,)_3'(G,A,B,D,H,F).

:- block 'Unsafe.unsafe_lambda0_0_1_._1_(,)_3'(-,?,?,?,?,?),'Unsafe.unsafe_lambda0_0_1_._1_(,)_3'(?,?,?,?,-,?).
'Unsafe.unsafe_lambda0_0_1_._1_(,)_3'([],A,B,C,D,E):-makeShare(B,F),hnf(if_then_else(apply(partcall(1,all,[partcall(1,'Char.isSpace',[])]),F),A,error(++(['\'U','\'n','\'s','\'a','\'f','\'e','\'.','\'r','\'e','\'a','\'d','\'A','\'n','\'y','\'U','\'n','\'q','\'u','\'a','\'l','\'i','\'f','\'i','\'e','\'d','\'T','\'e','\'r','\'m','\':','\' ','\'n','\'o','\' ','\'p','\'a','\'r','\'s','\'e','\',','\' ','\'u','\'n','\'m','\'a','\'t','\'c','\'h','\'e','\'d','\' ','\'s','\'t','\'r','\'i','\'n','\'g','\' ','\'a','\'f','\'t','\'e','\'r','\' ','\'t','\'e','\'r','\'m','\':','\' '],F))),C,D,E).
'Unsafe.unsafe_lambda0_0_1_._1_(,)_3'([A|B],C,D,E,F,G):-hnf(error(['\'U','\'n','\'s','\'a','\'f','\'e','\'.','\'r','\'e','\'a','\'d','\'A','\'n','\'y','\'U','\'n','\'q','\'u','\'a','\'l','\'i','\'f','\'i','\'e','\'d','\'T','\'e','\'r','\'m','\':','\' ','\'a','\'m','\'b','\'i','\'g','\'u','\'o','\'u','\'s','\' ','\'p','\'a','\'r','\'s','\'e']),E,F,G).
'Unsafe.unsafe_lambda0_0_1'([],A,B,C):-hnf(error(['\'U','\'n','\'s','\'a','\'f','\'e','\'.','\'r','\'e','\'a','\'d','\'A','\'n','\'y','\'U','\'n','\'q','\'u','\'a','\'l','\'i','\'f','\'i','\'e','\'d','\'T','\'e','\'r','\'m','\':','\' ','\'n','\'o','\' ','\'p','\'a','\'r','\'s','\'e']),A,B,C).

:- block 'Unsafe.unsafe_lambda1_0'(?,?,-,?).
'Unsafe.unsafe_lambda1_0'(A,B,C,D):-hnf(A,E,C,F),'Unsafe.unsafe_lambda1_0_1'(E,B,F,D).

:- block 'Unsafe.unsafe_lambda1_0_1'(-,?,?,?),'Unsafe.unsafe_lambda1_0_1'(?,?,-,?).
'Unsafe.unsafe_lambda1_0_1'([A|B],C,D,E):-hnf(A,F,D,G),'Unsafe.unsafe_lambda1_0_1_._1'(F,B,C,G,E).

:- block 'Unsafe.unsafe_lambda1_0_1_._1'(-,?,?,?,?),'Unsafe.unsafe_lambda1_0_1_._1'(?,?,?,-,?).
'Unsafe.unsafe_lambda1_0_1_._1'('(,)'(A,B),C,D,E,F):-hnf(C,G,E,H),'Unsafe.unsafe_lambda1_0_1_._1_(,)_3'(G,A,B,D,H,F).

:- block 'Unsafe.unsafe_lambda1_0_1_._1_(,)_3'(-,?,?,?,?,?),'Unsafe.unsafe_lambda1_0_1_._1_(,)_3'(?,?,?,?,-,?).
'Unsafe.unsafe_lambda1_0_1_._1_(,)_3'([],A,B,C,D,E):-hnf(if_then_else(apply(partcall(1,all,[partcall(1,'Char.isSpace',[])]),B),A,error(['\'U','\'n','\'s','\'a','\'f','\'e','\'.','\'r','\'e','\'a','\'d','\'A','\'n','\'y','\'Q','\'T','\'e','\'r','\'m','\':','\' ','\'n','\'o','\' ','\'p','\'a','\'r','\'s','\'e'])),C,D,E).
'Unsafe.unsafe_lambda1_0_1_._1_(,)_3'([A|B],C,D,E,F,G):-hnf(error(['\'U','\'n','\'s','\'a','\'f','\'e','\'.','\'r','\'e','\'a','\'d','\'A','\'n','\'y','\'Q','\'T','\'e','\'r','\'m','\':','\' ','\'a','\'m','\'b','\'i','\'g','\'u','\'o','\'u','\'s','\' ','\'p','\'a','\'r','\'s','\'e']),E,F,G).
'Unsafe.unsafe_lambda1_0_1'([],A,B,C):-hnf(error(['\'U','\'n','\'s','\'a','\'f','\'e','\'.','\'r','\'e','\'a','\'d','\'A','\'n','\'y','\'Q','\'T','\'e','\'r','\'m','\':','\' ','\'n','\'o','\' ','\'p','\'a','\'r','\'s','\'e']),A,B,C).

:-costCenters(['']).




%%%%% Number of shared variables: 4
